<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects;

use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhu;
use Seka\Portal\Modul\Statistiky\Tests\TestCase;

/**
 * Class PocetKontrolPodlaDruhuTest
 *
 * @package Seka\Portal\Modul\Statistiky\Tests\Unit\Entities\Zaznam\ValueObjects
 */
class PocetKontrolPodlaDruhuTest extends TestCase
{
    /**
     *
     */
    public function test_create_instance()
    {
        $pocetKontrolPodlaDruhu = new PocetKontrolPodlaDruhu(DruhEmisnejKontrolyEnum::PRAVIDELNA, 15);

        self::assertInstanceOf(PocetKontrolPodlaDruhu::class, $pocetKontrolPodlaDruhu);
    }

    /**
     *
     */
    public function test_transformation_to_array()
    {
        $pocetKontrolPodlaDruhu = new PocetKontrolPodlaDruhu(DruhEmisnejKontrolyEnum::PRAVIDELNA, 15);
        $arrayOutput = $pocetKontrolPodlaDruhu->toArray();

        self::assertIsArray($arrayOutput);
        self::assertArrayHasKey('druh', $arrayOutput);
        self::assertArrayHasKey('pocet', $arrayOutput);
    }

    /**
     *
     */
    public function test_transformation_to_json()
    {
        $pocetKontrolPodlaDruhu = new PocetKontrolPodlaDruhu(DruhEmisnejKontrolyEnum::PRAVIDELNA, 15);
        $jsonString = $pocetKontrolPodlaDruhu->jsonSerialize();

        self::assertJson($jsonString);
        self::assertJsonStringEqualsJsonString('{"druh":"PRAVIDELNA","pocet":15}', $jsonString);
    }
}
